unit mainform;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TMain }

  TMain = class(TForm)
    BtnAscA: TButton;
    BtnAscB: TButton;
    BtnGenerate: TButton;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    TxtTask: TEdit;
    procedure BtnAscAClick(Sender: TObject);
    procedure BtnAscBClick(Sender: TObject);
    procedure BtnGenerateClick(Sender: TObject);
    procedure ShowAssoc(ABit: Byte; AName: String);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Main: TMain;

implementation

uses
  sha1;

{$R *.lfm}

procedure TMain.BtnAscAClick(Sender: TObject);
begin
  ShowAssoc(0, 'A');
end;

procedure TMain.BtnAscBClick(Sender: TObject);
begin
  ShowAssoc(1, 'B');
end;

procedure TMain.BtnGenerateClick(Sender: TObject);
var
  a, b : Integer;
begin
  Randomize;
  a := Random(10000);
  b := Random(10000);
  TxtTask.Text := Format('%0.4d-%0.4d', [a, b]);
end;

procedure TMain.ShowAssoc(ABit: Byte; AName: String);
var
  TaskNumber: String;
  Hash : TSHA1Digest;
  AByte: Byte;
  Assoc: String;
  i : integer;
begin
  TaskNumber := Trim(TxtTask.Text);
  if Length(TaskNumber) < 4 then begin
    MessageDlg('Error', 'Task number must have at least 4 digits',
      mtError, [mbOK], '');
  end
  else begin
    Hash := SHA1String(TaskNumber);
    AByte := 0;
    for i := 0 to 19 do
      AByte := AByte xor Hash[i];
    for i := 0 to 7 do
      ABit := ABit xor ((AByte >> i) and 1);
    if ABit = 1 then
      Assoc := 'LONG'
    else
      Assoc := 'SHORT';
    MessageDlg('Decoded', 'In task number ' + TaskNumber + LineEnding +
      'image ' + AName + ' means ' + Assoc, mtInformation, [mbOK], '');
  end;
end;

end.


